#TODO
#dodelat kontroly navratoveho stavu


#aptitude install virtualenv
#virtualenv -p /usr/bin/python3.4 env
#. env/bin/activate
#pip install configparser click requests flask
##aptitude install python-configparses




#Examples:
#python3 robot.py --repo pilatcen/robotrepo  --configfile config.ini
#python3 robot.py --repo pilatcen/robotrepo --checkevery 1  --configfile config.ini --defaultlabel "Bump!" --searchcomments




import re
import json
import time
import click
import pprint
import requests
import configparser
from flask import Flask, request, render_template


app = Flask(__name__)



#Copied from https://wiki.python.org/moin/ConfigParserExamples
def ConfigSectionMap(Config, section):
	dict1 = {}
	options = Config.options(section)
	for option in options:
		try:
			dict1[option] = Config.get(section, option)
			if dict1[option] == -1:
				DebugPrint("skip: %s" % option)
		except:
			print("exception on %s!" % option)
			dict1[option] = None
	return dict1



def comments(session, url):
	r = session.get(url+'/comments')
	comments=""
	for comment_id in range(0, len(r.json())):
		comments = comments + " " + r.json()[comment_id]['body']
		
	return comments
		
	
def login(token):
	""" Login and nothing more """
	session = requests.Session()
	r = session.headers = {'Authorization': 'token ' + token, 'User-Agent': 'Python'}
	return session
	
	
#GET /repos/:owner/:repo/issues/:number
def tag_issue(issue_url, session, rules, search_in_comments, default_rule):
	labelled=False
	r = session.get(issue_url)
	content=r.json()['title'] + " " + r.json()['body']
	labels=r.json()['labels']
	
	if (search_in_comments == True):
		content=content + " " + comments(session, issue_url)
		
	for rule in rules:
		if (len(labels) == 0):
			match = re.search(rule[0], content)
			if (match):
				print("u issue "+issue_url+" nalezeno: "+rule[0]+", labeluji: "+rule[1])
				result = session.post(issue_url+"/labels", data='["'+rule[1]+'"]')
				pprint.pprint (result.json())
				labelled=True
	print ("Pocet labelu u issue "+ issue_url +": " + str(len(labels)))
	if ((labelled == False) and (len(labels) == 0) and (default_rule)):
		#default rule here
		result = session.post(issue_url+"/labels", data='["'+default_rule+'"]')
		pprint.pprint (result.json())

def tag_with_labels (session, repo, search_in_comments, check_every, rules = [], default_rule = []):
	""" tagging function """
	
	r = session.get('https://api.github.com/user')
	
	while True:
		r = session.get('https://api.github.com/repos/'+repo+'/issues')
		issues_count=len(r.json())
		print("Pocet issues v repu: " + str(issues_count))
		
		for issue_id in range(0, issues_count):
			tag_issue(r.json()[issue_id]['url'], session, rules, search_in_comments, default_rule)
		
		if (check_every == 0):
			break;
			
		time.sleep(check_every)







@click.group()
def cli():
	pass



@cli.command()
@click.option('--repo', help='Repository name on github.com in format username/repositoryname', required=True)
@click.option('--checkevery', default=0, help='Number of seconds between next check for unlabelled issues')
@click.option('--defaultlabel', help='When issue is unlabelled and no rule set a label then default will be is used')
@click.option('--configfile', type=click.Path('r'), help='Path to configuration file, where auth token and label rules are stored', required=True)
@click.option('--searchcomments/--no-searchcomments', default=False, help='Turn on labelling based on keywords in issue comments')


def console(repo, checkevery, defaultlabel, searchcomments, configfile):
	
	Config = configparser.ConfigParser()
	Config.read(configfile)
	Config.sections()

	token = ConfigSectionMap(Config, "github")['token']
	rules = json.loads(ConfigSectionMap(Config, "github")['rules'])
	
	session = login(token)
	
	tag_with_labels (session, repo, searchcomments, checkevery, rules, defaultlabel)
	
	
	
	
	
	return 0


@cli.command()
@click.option('--defaultlabel', help='When issue is unlabelled and no rule set a label then default will be is used')
@click.option('--configfile', type=click.Path('r'), help='Path to configuration file, where auth token and label rules are stored', required=True)
@click.option('--searchcomments/--no-searchcomments', default=False, help='Turn on labelling based on keywords in issue comments')
def web(configfile = "config.ini", defaultlabel = "", searchcomments = False):
	app.run(debug=True)
	
	web_label(configfile, defaultlabel, searchcomments)
	
	



@app.route('/hook', methods=['POST'])
def web_label(configfile = "config.ini", defaultlabel = "", searchcomments = False):

	
	Config = configparser.ConfigParser()
	Config.read(configfile)
	Config.sections()
	
	
	token = ConfigSectionMap(Config, "github")['token']
	rules = json.loads(ConfigSectionMap(Config, "github")['rules'])
	
	defaultlabel = ConfigSectionMap(Config, "github")['defaultlabel']
	searchcomments = ConfigSectionMap(Config, "github")['searchcomments']
	
	session = login(token)
	issue_url=request.get_json()['issue']['url']

	
	tag_issue(issue_url, session, rules, searchcomments, defaultlabel)
	
	
	
	
	return 'OK'

@app.route('/')
def usage():
	return render_template('usage.html')



	

#if __name__ == '__main__':
def main():
	app.config['TEMPLATES_AUTO_RELOAD'] = True
	cli()
