from setuptools import setup


with open('readme.md') as f:
	long_description = ''.join(f.readlines())


setup(
	install_requires=['Flask', 'configparser', 'click', 'requests'],
	name='github-robot',
	version='0.6',
	description='Tags github issue with labels defined by regular expression',
	long_description=long_description,
	author='pilatcen',
	author_email='pilatcen@fit.cvut.cz',
	keywords='github,issues,labelling',
	license='GNU GPL v3',
	url='https://github.com/pilatcen/github-robot',
	packages=['githubrobot'],
	classifiers=[
		'Operating System :: POSIX :: Linux',
		'License :: Public Domain',
		'Programming Language :: Python :: 3 :: Only',
		'Programming Language :: Python :: 3.4',
		'Development Status :: 4 - Beta',
		'Environment :: Web Environment',
		'Environment :: Console',
		'Framework :: Flask',
		'License :: OSI Approved :: GNU General Public License v3 (GPLv3)',
	],
	entry_points={
		'console_scripts': [
			'githubrobot = githubrobot:main',
		],
	},
	package_data={
        'githubrobot': [
            'templates/usage.html',
            'config.ini.template'
        ]
    },
)
